{+=============================================================================+
 | TLogFile    created on 29.12.1997            By RicoSoft rico@mbox.4net.it  |
 | last updated:     1.0a 25.12.1997           Riccardo 'Rico' Pareschi, Italy |
 +-----------------------------------------------------------------------------+
  This small component is based on an idea by Song Weng Sam.
  Is a Log File component for debugging pourpouse.
 +-----------------------------------------------------------------------------+
  This is Freeware/Careware. I put it on the net for the other programmers.
  I've write some small 'CareWare' programs and a lot of serious professional
  applications. This routines are presents in my works.
 +-----------------------------------------------------------------------------+
  This file is released to the Public Domain. Please use, share & enjoy. Rico.
===============================================================================}
unit LogFile;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs;

type
  TLogFile = class(TComponent)
  private
    { Private declarations }
    FLogFile: string;
    LogFx   : text;
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;

    procedure OpenLogFile;
    procedure CloseLogFile;
    procedure WriteLogFile(Msg: string);
  published
    { Published declarations }
    property  LogFile: String read FLogFile write FLogFile;
  end;

procedure Register;

implementation

{-------------------------------------------------------------------------------
  Change here for a different component palette
}
procedure Register;
begin
  RegisterComponents('Rico', [TLogFile]);
end; {- Register }

{-------------------------------------------------------------------------------
}
constructor TLogFile.Create(AOwner: TComponent);
begin
   inherited Create(AOwner);
   FLogFile := '';
end; {- Create }

{-------------------------------------------------------------------------------
  The open method. Build the complete filename using the Application path with
  a extension .DLF (debug log file) on a text file, so you can read it with
  notepad or delphi editor.
  Then write a Login message with date & time. The flush() function guarantees
  that all characters written to the file at that time have actually been
  written to the external file.
}
procedure TLogFile.OpenLogFile;
begin
  FLogFile := ExtractFilePath(Application.ExeName) + FLogFile + '.DLF';
  AssignFile(LogFx, FLogFile);
  if FileExists(FLogFile) then
     Append(LogFx)
  else Rewrite(LogFx);

  Writeln(LogFx, FormatDateTime('"Login :" dddd, dd mmmm yyyy - hh:mm', Now));
  Flush(LogFx);
end; {- OpenLogFile }

{-------------------------------------------------------------------------------
  Write the "event" with time & message, then flush.
}
procedure TLogFile.WriteLogFile(Msg: string);
begin
  Writeln(LogFx, FormatDateTime('hh:mm "--> "', Now) + Msg);
  Flush(LogFx);
end; {- WriteLogFile }

{-------------------------------------------------------------------------------
  Closing with a Logout label with date & time, a separator then flush() and
  close() the file.
}
procedure TLogFile.CloseLogFile;
begin
  Writeln(LogFx, FormatDateTime('"Logout:" dddd, dd mmmm yyyy - hh:mm', Now));
  Writeln(LogFx, '-------');
  Flush(LogFx);
  CloseFile(LogFx);
end; {- CloseLogFile }

end.
